
#include <Arduino.h>
#include <Wire.h>
#include "Keyboard.h"
#include "Rfid.h"
#include "Interface.h"
#include <vector>

// Rfid
Rfid rfid;
// i2C Bus
#define PIN_WIRE_SDA D3
#define PIN_WIRE_SCL D4

Keyboard keyboard(200);
Interface iface;

// User DB

typedef struct
{
	String uid;
	String first_name;
	String last_name;
	String rfid_uid;
	String user_pin;
} user_account;
std::vector<user_account> userdb;
void setup()
{
	Serial.begin(9600);
	Serial.print("Starting");
	delay(500);
	keyboard.begin(&Wire);
	rfid.begin();
	iface.begin(&keyboard);
	userdb.push_back(user_account{.uid = "010202", .first_name = "Max", .last_name = "Mustermann and Sons", .rfid_uid = "D3 4E 03 0B", .user_pin = "1212"});
	userdb.push_back(user_account{.uid = "012345", .first_name = "John", .last_name = "Doe", .rfid_uid = "8C 75 6C 17", .user_pin = "2424"});
}

void loop()
{
	keyboard.scanAsync();
	rfid.scan();
	if (iface.pinAvailable())
	{
		String entered_pin = iface.getPin();
		std::for_each(userdb.begin(), userdb.end(), [=](user_account user)
					  {
						  if (entered_pin == user.user_pin)
						  {
							  iface.greetUser(user.first_name + " " + user.last_name);
						  }
					  });
	}
	std::cop
	else if (rfid.available())
	{
		String rfid_card_uid = rfid.getID();
		std::for_each(userdb.begin(), userdb.end(), [=](user_account user)
					  {
						  if (rfid_card_uid == user.rfid_uid)
						  {
							  iface.greetUser(user.first_name + " " + user.last_name);
						  }
					  });
	}
	iface.render();
}